package bugdb;
@ISA = qw(sql);

use strict;
use sql;

sub get_password_by_user_id {
	my ($self, $user_id) = @_;

	my $rows = $self->fetch_hash_SQL("SELECT cryptpassword from profiles ".
			"WHERE userid='$user_id'");
	return $rows->[0]->{'cryptpassword'} if exists $rows->[0];
}

sub get_tag_by_comment_id {
	my $self = shift;
	my $id = shift;

	my $rows = $self->fetch_hash_SQL(
			"select tag from comment_tags where comment_id='$id'");
	return $rows->[0]->{tag} if exists $rows->[0];
}


sub get_bug_property {
	my $self = shift;
	my $bug_id = shift;
	my $property = shift;

	my $rows = $self->fetch_hash_SQL(
		"select $property from bugs where bug_id='$bug_id'");
	return $rows->[0]->{$property} if exists $rows->[0];
	return undef;
}

# The last time the ticket's status was flipped from new to another status
sub get_started {
	my $self = shift;
	my $bug_id = shift;
	my $sql = "SELECT ba.bug_when from bugs_activity ba, fielddefs fd ".
		  "WHERE fd.name='bug_status' and fd.fieldid=ba.fieldid ".
		  "AND removed='NEW' and bug_id=$bug_id ".
		  "ORDER by bug_when desc limit 1";
	my $rows = $self->fetch_hash_SQL($sql);
	return $rows->[0]->{bug_when} if exists $rows->[0];
	return undef;
}

# The last time that this ticket's status was set to
# resolved, rejected, deleted
sub get_resolved {
	my $self = shift;
	my $bug_id = shift;

	my $sql = "SELECT ba.bug_when from bugs_activity ba, fielddefs fd ".
		  "WHERE fd.name='bug_status' and fd.fieldid=ba.fieldid ".
		  "AND added='RESOLVED' and bug_id=$bug_id ".
		  "ORDER by bug_when desc limit 1";
	my $rows = $self->fetch_hash_SQL($sql);
	return $rows->[0]->{bug_when} if exists $rows->[0];
	# Resolved is automatically set to current during creation if
	# resolved is missing in the parameter list.
	# We set it to 0 by default
	return '1970-01-01 00:00:00';
}

sub get_lastupdate {
	my ($self, $bug_id) = @_;

# XXX enough to search bugs_activity only?
        my $rows = $self->fetch_hash_SQL(
			"SELECT who,bug_when from bugs_activity ".
			"WHERE bug_id=$bug_id ".
			"ORDER by bug_when desc limit 1");
	return ($rows->[0]->{who}, $rows->[0]->{bug_when}) if exists $rows->[0];
	return (0, '1970-01-01 00:00:00');
}

# bugzilla doesn't tell us the creation date for product, we just set it to
# the time the first bug was created in this product.
sub get_prod_created {
	my $self = shift;
	my $prod = shift;
	my $rows = $self->fetch_hash_SQL("SELECT creation_ts from bugs ".
			"WHERE product_id=$prod ORDER by creation_ts limit 1");
	return $rows->[0]->{creation_ts} if exists $rows->[0];
	return undef;
}


# bugzilla doesn't tell us the creation date for component, we just set it to
# the time the first bug was created in this component.
sub get_comp_created {
	my ($self, $prod, $comp) = @_;

	my $rows = $self->fetch_hash_SQL("SELECT creation_ts from bugs ".
			"WHERE product_id=$prod and component_id=$comp ".
			"ORDER by creation_ts limit 1");
	return $rows->[0]->{creation_ts} if exists $rows->[0];
	return undef;
}

1;
