#!/usr/bin/perl  
use strict;
use myUtil;
use rtdb;
use bugdb;

use lib "/opt/rt3/lib";
use lib "/usr/lib/rt";
use RT;
RT::LoadConfig();
my $dbpass;
if (@ARGV < 1) {
	$dbpass = '';
}
else {
	$dbpass = $ARGV[0];
}

my $rtdb = rtdb->new(
		database => $RT::DatabaseName,
		user     => 'root',
		password => $dbpass
		);
my $bugdb = bugdb->new(
		database => 'bugs',
		user     => 'root',
		password => $dbpass
		);


# This functon is used to create 
sub create_map_tables {
	$rtdb->execSQL("DROP TABLE IF EXISTS prod_bug2rt",0);
	$rtdb->execSQL("create table prod_bug2rt(id int(11) NOT NULL auto_increment, ".
		"bug_prod_id int(11) NOT NULL, rt_queues_id int(11) NOT NULL, PRIMARY key (id))",0);
}


sub insert_product_id {
        my $rows = $bugdb->fetch_hash_SQL(
			"select id, name from products order by id");
        for my $row (@$rows){
                my $bug_id = $row->{'id'};
                my $name = $row->{'name'};
                my $rt_id = $rtdb->get_queue_id_by_name($name);
                my $sql = "insert into prod_bug2rt(bug_prod_id,rt_queues_id)"
			." values('$bug_id','$rt_id')";
                $rtdb->execSQL($sql,0);
        }
}


sub run {
	create_map_tables();
	insert_product_id();
}
run();


$bugdb->disconnect();
$rtdb->disconnect();
