#!/bin/sh
echo -n "Please input the database password for root: "
stty -echo
read passwd
stty echo
echo

setup=`rpm -ql rt |grep rt-setup-database`
if [ ! $setup ] ; then
    setup=/opt/rt3/sbin/rt-setup-database
fi
# users and groups
create_user(){
    passwd=$1
    perl $setup --action drop --dba root --dba-password $passwd

    # don't insert scrip here
    perl bugimport --action init --dba root --dba-password $passwd
    perl print_users_groups.pl $passwd >data.pl 
    perl $setup --action insert --datafile ./data.pl --dba root --dba-password $passwd
    perl insert_ids_map.pl $passwd
}

# bugs
create_ticket(){
    passwd=$1
    perl print_prod.pl $passwd>./data.pl
    perl $setup --action insert --datafile ./data.pl --dba root --dba-password $passwd
    perl insert_prod_id.pl $passwd

    echo -n Preparing data to create tickets...
    perl print_bugs.pl $passwd> ./data.pl
    echo done.
    perl bugimport --action insert --datafile ./data.pl --dba root --dba-password $passwd
}


# transactions
create_trans(){
    passwd=$1
    perl transactions.pl $passwd
}

# update
create_update(){
    passwd=$1
    perl update_create.pl $passwd
    perl create_scrip --action init --dba root --dba-password $passwd
}

stage=$1
if [ ! $stage ] ; then
    for s in 'user' 'ticket' 'trans' 'update' ; do
    create_$s $passwd
    done
else
    create_$stage $passwd
fi
rm -f data.pl
echo All done.
