package myUtil;

use strict;
use Date::Manip;


sub hour2min
{
	my $hour = shift;
	return $hour * 60 if defined $hour;
	return 0;
}


sub print_hash{
	my $a = shift;
	while ((my $k,my $v) =  each %$a) {
              print "$k => $v\n";
        }

}

sub print_rows{
	my $a = shift;
	for my $row (@$a){
		print "{\n";
		while ((my $k,my $v) =  each %$row) {
			print "$k => $v\n";
		}
		print "}\n";
 	}
}

sub iso_date {
    my $date = shift;

    $date = ParseDate($date);
    return UnixDate($date, '%Y-%m-%d %T');
}


sub cc_type {
	my $email = shift;

	return "AdminCc" if $email =~ /\@clusterfs.com$/;
	return "Cc";
}

sub status_bugzilla2rt {
	my $stat = shift;

	my %status_map = (
                NEW      => "new",
                ASSIGNED => "open",
                REOPENED => "open",
                RESOLVED => "resolved",
                VERIFIED => "resolved",
                CLOSED   => "resolved",
                UNCONFIRMED => "resolved"
		);
	return $status_map{$stat} if exists $status_map{$stat};
	return '';
}

sub priority_bugzilla2rt {
	my $prio = shift;

	my %priority_map = (
                P1 => 90,
                P2 => 70,
                P3 => 50,
                P4 => 30,
                P5 => 10,
		);
	return $priority_map{$prio} if exists $priority_map{$prio};
	return '';
}

# list to quote string
sub list2qstring {
	my @list = @_;
	my $str = '';

	for my $i (0 .. scalar @list - 1) {
		$str .= "'". $list[$i] ."',";
	}
	chop $str;
	return $str;
}

1;
