#!/usr/bin/perl  
use strict;
use myUtil;
use rtdb;
use bugdb;

use lib "/opt/rt3/lib";
use lib "/usr/lib/rt";
use RT;
RT::LoadConfig();
my $dbpass;
if (@ARGV < 1) {
	$dbpass = '';
}
else {
	$dbpass = $ARGV[0];
}

my $rtdb = rtdb->new(
		database => $RT::DatabaseName,
		user     => 'root',
		password => $dbpass
		);
my $bugdb = bugdb->new(
		database => 'bugs',
		user     => 'root',
		password => $dbpass
		);


sub print_prod {
	my $rows = $bugdb->fetch_hash_SQL("select * from products");
	my $root_id = $rtdb->get_root_id();
	print "\@Queues = (\n";
	my $i = 0;
	for my $row (@$rows){
		$i = $i +1;
		if($i >1){
		 	print ",\n\t},\n";
		}
		my $desc = $rtdb->quote($row->{description});
		my $created = 'now()';
		my $returned = $bugdb->get_prod_created($row->{id});
		$created = $rtdb->quote($returned)
			if defined $returned;
		print "\t{ Name\t=> '$row->{'name'}',\n";
		print "\t  Description\t=> $desc,\n";
		print "\t  Created\t=> $created,\n";
		print "\t  Creator\t=> '$root_id',\n";
		#print "\t  LastUpdated\t=> 'now()',\n";
                #print "\t  LastUpdatedBy\t=> '$root_id'";
	}
	print ", } );\n";
}


sub run {
	print_prod();
}


run();

$bugdb->disconnect();
$rtdb->disconnect();
