#!/usr/bin/perl  
use strict;
use myUtil;
use rtdb;
use bugdb;

use lib "/opt/rt3/lib";
use lib "/usr/lib/rt";
use RT;
RT::LoadConfig();
my $dbpass;
if (@ARGV < 1) {
	$dbpass = '';
}
else {
	$dbpass = $ARGV[0];
}


my $rtdb = rtdb->new(
		database => $RT::DatabaseName,
		user     => 'root',
		password => $dbpass
		);
my $bugdb = bugdb->new(
		database => 'bugs',
		user     => 'root',
		password => $dbpass
		);

sub print_users {
	my $rows = $bugdb->fetch_hash_SQL("select * from profiles");
	print "\@Users = (\n";
	my $i = 0;
	for my $row (@$rows){
		$i = $i +1;
		if ($i > 1) {
		 	print "\t},\n";
		}
		#my $name = substr($row->{'login_name'},0,index($row->{"login_name"},"@"));
		#print "\t{ Name\t=> ".$bugdb->quote($name).",\n";
		print "\t{ Name\t=> ".$bugdb->quote($row->{login_name}).",\n";
		print "\t  EmailAddress\t=> ".$bugdb->quote($row->{login_name}).",\n";
		print "\t  RealName\t=> ".$bugdb->quote($row->{realname}).",\n";
		print "\t  Comments\t=> ".$bugdb->quote($row->{disabledtext}).",\n"
			if (length($row->{disabledtext}) > 0);
		print "\t  Privileged\t=> '1',\n";
		#print "\t  LastUpdated\t=> '$row->{'refreshed_when'}'";
	}
	print ",}\n);\n";
}

sub print_groups {
	my $rows = $bugdb->fetch_hash_SQL("select * from groups");
	print "\@Groups = (\n";
	my $i = 0;
	for my $row (@$rows) {
		$i = $i + 1;
		if ($i > 1) {
		 	print "\t},\n";
		}
		print "\t{ Name\t=> ".$bugdb->quote($row->{name}).",\n";
		#print "\t  Type\t=> '',\n";
		print "\t  Domain\t=> 'UserDefined',\n";
		#print "\t  Instance\t=> '',\n";
		print "\t  Description\t=> ".$bugdb->quote($row->{description})."";
	}
	print ",}\n);\n";
}

sub run {
	print_users();
	print_groups();
}
run();

$bugdb->disconnect();
$rtdb->disconnect();
