package rtdb;

@ISA = qw(sql);
use strict;
use sql;


sub get_user_id_by_bug_user_id {
	my ($self, $bug_user_id) = @_;

        my $rows = $self->fetch_hash_SQL("SELECT rt_user_id from user_bug2rt ".
			"WHERE bug_user_id='$bug_user_id'");
	return $rows->[0]->{rt_user_id} if exists $rows->[0];
}


sub get_next_principal {
	my $self = shift;

	my $rows = $self->fetch_hash_SQL(
			"SELECT id from Principals order by id desc limit 1");
	return $rows->[0]->{id} + 1;
}


sub create_user {
	my $self = shift;
	my %arg = @_;

	return 0 if (%arg == 0);
	return 0 unless exists $arg{Name};

	$arg{id} = $self->get_next_principal() unless exists $arg{id};
	my $sql = "INSERT into Users(Name";
	$sql .= ",EmailAddress" if exists $arg{EmailAddress};
	$sql .= ",Password" if exists $arg{Password};
	$sql .= ",RealName" if exists $arg{RealName};
	$sql .= ",Comments" if exists $arg{Comments};
	$sql .= ",id";
	$sql .= ",Creator,Created,LastUpdatedBy,LastUpdated) VALUES(";
	$sql .= $self->quote($arg{Name});
	$sql .= "," . $self->quote($arg{EmailAddress}) if exists $arg{EmailAddress};
	$sql .= "," . $self->quote($arg{Password}) if exists $arg{Password};
	$sql .= "," . $self->quote($arg{RealName}) if exists $arg{RealName};
	$sql .= "," . $self->quote($arg{Comments}) if exists $arg{Comments};
	$sql .= "," . $self->quote($arg{id});
	my $created = 'now()';
	$created = $self->quote($arg{Created}) if exists $arg{Created};
	my $lastupdated = 'now()';
	$lastupdated = $self->quote($arg{LastUpdated}) if exists $arg{LastUpdated};
	my $creator = $arg{Creator} if exists $arg{Creator};
	$creator = $self->get_root_id() unless defined $creator;
	my $updatedBy = $arg{LastUpdatedBy} if exists $arg{LastUpdatedBy};
	$updatedBy = $self->get_root_id() unless defined $updatedBy;
	$sql .= ",$creator,$created,$updatedBy,$lastupdated)";
	$self->execSQL($sql);

	$sql  = "INSERT into Principals(PrincipalType,ObjectId";
	$sql .= ",Disabled" if exists $arg{Disabled};
	$sql .= ") VALUES (";
	$sql .= "'User',$arg{id}";
	$sql .= ",$arg{Disabled}" if exists $arg{Disabled};
	$sql .= ")";
	$self->execSQL($sql);
	return $arg{id};
}

sub get_user_id_by_name {
	my ($self, $name) = @_;

	my $rows = $self->fetch_hash_SQL("SELECT id from Users ".
			"WHERE Name='$name'");
	return $rows->[0]->{id} if exists $rows->[0];
	return 0;
}


sub get_user_id_by_email {
	my ($self, $email, $create) = @_;

	my $rows = $self->fetch_hash_SQL("SELECT id from Users ".
			"WHERE EmailAddress='$email'");
	return $rows->[0]->{id} if exists $rows->[0];
	if ($create) {
		return $self->create_user(
				Name        => $email,
				EmailAddress=> $email,
				Disabled    => 1,
				Comments    => 'Autocreated when added as a watcher'
				);
	}
	return undef;
}

sub get_bug_user_id_by_user_id {
	my ($self, $rt_user_id) = @_;

	my $rows = $self->fetch_hash_SQL("SELECT bug_user_id FROM user_bug2rt ".
			"WHERE rt_user_id=$rt_user_id");
	return $rows->[0]->{bug_user_id} if exists $rows->[0];
}

sub get_email_by_user_id {
	my ($self, $id) = @_;

	my $rows = $self->fetch_hash_SQL("SELECT EmailAddress from Users ".
			"WHERE id='$id'");
	return $rows->[0]->{EmailAddress} if exists $rows->[0];
}

sub get_CustomField_id_by_name {
	my $self = shift;
	my $name = shift;
	my $lookupType = shift;

	my $sql = "SELECT id from CustomFields WHERE Name='$name'";
	$sql .= " and LookupType='$lookupType'" if defined $lookupType;
        my $rows = $self->fetch_hash_SQL($sql);
	return $rows->[0]->{id} if exists $rows->[0];
}

# op_sys_details, *version, target_milestone, qa_contact, *status_whiteboard,
# votes, keywords, *alias, version_details, rep_platform, *bug_severity,
# op_sys

# bug_severity version rep_platform op_sys will be in 'Select' format in +
# print_bugs.pl

# map{bugzilla-name} = [customField-name, sortorder, customField-id]
sub customField_map {
	my $self = shift;

	my %map = (
                # add/remove custom fields for ticket here
		# name in bugzilla, name in RT, sortOrder
		alias             => ['Alias',             1],
		version           => ['Version',           2],
		status_whiteboard => ['Status Whiteboard', 3],
		bug_severity      => ['Severity',          4],
		);

	for my $key (keys %map) {
		$map{$key}->[2] = $self->get_CustomField_id_by_name
			($map{$key}->[0], 'RT::Queue-RT::Ticket');
	}
	return %map;
}


sub get_queue_id_by_name {
	my ($self, $name) = @_;

        my $rows = $self->fetch_hash_SQL("SELECT id from Queues ".
			"WHERE Name='$name'");
	return $rows->[0]->{id} if exists $rows->[0];
}

sub get_queue_id_by_prod {
	my ($self, $prod_id) = @_;

	my $rows=$self->fetch_hash_SQL("SELECT rt_queues_id from prod_bug2rt ".
			"WHERE bug_prod_id='$prod_id'");
	return $rows->[0]->{rt_queues_id} if exists $rows->[0];
}

sub get_lastupdate {
	my ($self, $bug_id) = @_;

        my $rows = $self->fetch_hash_SQL(
			"SELECT Creator,Created from Transactions ".
			"WHERE ObjectType='RT::Ticket' and ObjectId='$bug_id' ".
			"ORDER by Created desc limit 1"
			);
	return ($rows->[0]->{Creator}, $rows->[0]->{Created}) if exists $rows->[0];
}

sub get_root_id {
	my $self = shift;

	my $rows = $self->fetch_hash_SQL("SELECT id from Users ".
			"WHERE Name='root'");
	return $rows->[0]->{id} if exists $rows->[0]; 
}

sub insert_customFields {
	my $self = shift;
	my %arg = @_;

	my $max = 1;
	$max = $arg{MaxValues} if exists $arg{MaxValues};
	my $root_id = $self->get_root_id();
	$self->execSQL("INSERT into CustomFields".
		       "(Name,Type,MaxValues,LookupType,".
		       "Creator,Created,LastUpdatedBy,LastUpdated)".
		       "VALUES".
		       "('$arg{Name}','$arg{Type}',$max,'$arg{LookupType}',".
		       "$root_id,now(),$root_id,now())");
}

sub insert_CustomFieldValues {
	my $self = shift;
	my $cf_name = shift;
	my (@values) = @_;
	my $cf_id = $self->get_CustomField_id_by_name($cf_name);
	my $id = $self->get_root_id();
	my $i = 0;
	for my $v (@values) {
		$self->execSQL(
		"insert into CustomFieldValues(CustomField,Name,SortOrder,".
		"Creator,Created,LastUpdatedBy,LastUpdated) values(".
		"'$cf_id',".$self->quote($v).",'$i','$id',now(),'$id',now())");
		$i += 1;
	}
}

sub insert_ObjectCustomFieldValues {
	my $self = shift;
	my %arg = @_;
        my $sql;

	my $content = 'Content';
	$content = 'LargeContent' if (length($arg{Content}) >= 255);
	my $created = 'now()';
	$created = $self->quote($arg{Created}) if exists $arg{Created};
	my $lstUpdated = 'now()';
	$lstUpdated = $self->quote($arg{LastUpdated}) if exists $arg{LastUpdated};

        $sql = "INSERT into ObjectCustomFieldValues".
	       "(CustomField,ObjectType,ObjectId,".
	       "$content,Creator,Created,".
	       "LastUpdatedBy,LastUpdated) ".
	       "VALUES".
	       "($arg{CustomField},'$arg{ObjectType}',$arg{ObjectId},".
	       $self->quote($arg{Content}).",'$arg{Creator}',$created,".
	       "'$arg{LastUpdatedBy}',$lstUpdated)";
        $self->execSQL($sql,0);
}

1;
