package sql;

use strict;
use DBI;

sub new {
	my $class = shift;
	my $self = {};
	my %arg = @_;

	my $dbi = 'mysql';
	$dbi = $arg{dbi} if exists $arg{dbi};
	my $database = $arg{database};
	my $host = 'localhost';
	$host = $arg{host} if exists $arg{host};
	my $user = 'root';
	$user = $arg{user} if exists $arg{user};
	my $password = '';
	$password = $arg{password} if exists $arg{password};

	$self->{dbh} = DBI->connect("DBI:$dbi:database=$database;host=$host",
                         $user, $password,
                         {'RaiseError' => 1});
	return (bless $self, $class);
}

sub execSQL {
	my ($self, $sql, $is_debug) = @_;

	if ($is_debug) {
		print "$sql\n";
	} else {
		$self->{dbh}->do($sql);
	}
}

sub fetch_hash_SQL {
	my ($self, $sql) = @_; 

	my $sth = $self->{dbh}->prepare($sql);
	$sth->execute();
	my @results;
	while( my $_fetchahead = $sth->fetchrow_hashref()){
		push(@results, $_fetchahead);
	}
	$sth->finish(); 
	return \@results;
}

sub fetch_array_SQL {
	my ($self, $sql) = @_;

	my $sth = $self->{dbh}->prepare($sql);
	$sth->execute();
	my @result;
	while (my $row = $sth->fetchrow_array()) {
		push @result, $row;
	}
	$sth->finish(); 
	return @result;
}

sub quote {
	my $self = shift;
        my $str = shift;
        return $self->{dbh}->quote( $str );
}

sub disconnect {
	my $self = shift;

	$self->{dbh}->disconnect();
}

1;
